//--------------------------------------------------------//
//  Copyright John D. Thompson                            //
//--------------------------------------------------------//
#property indicator_chart_window
#property copyright "NexGen4x Pty Ltd"
#property link      "http://www.nexgen4x.com"

// External Variables
extern color               SymbolColor = Silver;
extern color               Above = Green;
extern color               Below = Red;
extern color               Mixed = Yellow;
extern bool                PopUpAlerts = TRUE;
extern bool                SoundAlerts = TRUE;
extern string              AlertSoundfile   = "Alert.wav";
extern bool                EmailAlerts = FALSE;
extern bool                alertsNotify     = true;
extern bool                SNP500 = TRUE;
extern bool                NASDAQ = TRUE;
extern bool                DOWJON = TRUE;
extern bool                US_OIL = TRUE;
extern bool                AUDUSD = TRUE;
extern bool                EURCAD = TRUE;
extern bool                EURCHF = TRUE;
extern bool                EURGBP = TRUE;
extern bool                EURJPY = TRUE;
extern bool                EURUSD = TRUE;
extern bool                GBPCHF = TRUE;
extern bool                GBPJPY = TRUE;
extern bool                GBPUSD = TRUE;
extern bool                NZDUSD = TRUE;
extern bool                USDCAD = TRUE;
extern bool                USDCHF = TRUE;
extern bool                USDJPY = TRUE;
extern bool                EURAUD = TRUE;

extern string _fha                    = "FAST Heiken Ashi Settings";
extern int    FastMaPeriod            = 10;
extern int    FastMaMetod             = 1;
extern int    FastStep                = 0;
extern bool   FastBetterFormula       = TRUE;
extern int    HAS_TF1                 = 15;
extern int    habar1                   = 1;
extern string _sha                    = "SLOW Heiken Ashi Settings";
extern int    SlowMaPeriod            = 10;
extern int    SlowMaMetod             = 1;
extern int    SlowStep                = 0;
extern bool   SlowBetterFormula       = TRUE;
extern int    HAS_TF2                 = 60;
extern int    habar2                   = 0;
extern string _sha1                    = "TREND Heiken Ashi Settings";
extern int    SlowerMaPeriod            = 14;
extern int    SlowerMaMetod             = 1;
extern int    SlowerStep                = 0;
extern bool   SlowerBetterFormula       = TRUE;
extern int    HAS_TF3                   = 240;
extern int    habar3                   = 0;













// Internal Variables
int                        spacer;
int                        sideways;
string                     ExtraSymbolChar;
string                     dash;
string                     Signal;
string                     LastSignal;
bool                       Row2 = FALSE;
string                     LastAlert;
string                     SNP500_LastSignal = "";
string                     NASDAQ_LastSignal = "";
string                     DOWJON_LastSignal = "";
string                     US_OIL_LastSignal = "";
string                     AUDUSD_LastSignal = "";
string                     EURCAD_LastSignal = "";
string                     EURCHF_LastSignal = "";
string                     EURGBP_LastSignal = "";
string                     EURJPY_LastSignal = "";
string                     EURUSD_LastSignal = "";
string                     GBPCHF_LastSignal = "";
string                     GBPJPY_LastSignal = "";
string                     GBPUSD_LastSignal = "";
string                     NZDUSD_LastSignal = "";
string                     USDCAD_LastSignal = "";
string                     USDCHF_LastSignal = "";
string                     USDJPY_LastSignal = "";
string                     EURAUD_LastSignal = "";


int init() 
{
   ObjectsDeleteAll(0);
   Comment("\nFX 3HAS Initialized,",
           "\n",
           "\nWaiting For Next Tick...");
   return (0);
}

int deinit() 
{
   ObjectsDeleteAll(0);
   return (0);
}

int start() 
{
   Comment("\n");
   // Detects extra characters after symbol name.
   ExtraSymbolChar = StringSubstr(Symbol(), 6, 10);
   
   // Detects a dash in middle of symbol name.
   if (StringSubstr(Symbol(), 4, 1) == "-") dash = "-";
   else dash = "";
   
   SetTitles();
   spacer = 50;
   Row2 = FALSE;
   if (SNP500) ProcessSymbol("#S&P"+dash+"500_H6"+ExtraSymbolChar);
   if (NASDAQ) ProcessSymbol("#NAS"+dash+"100_H6"+ExtraSymbolChar);
   if (DOWJON) ProcessSymbol("#DJ3"+dash+"0_H6"+ExtraSymbolChar);
   if (US_OIL) ProcessSymbol("#US_"+dash+"Oil_H6"+ExtraSymbolChar);
   if (AUDUSD) ProcessSymbol("AUD"+dash+"USD"+ExtraSymbolChar);
   if (EURCAD) ProcessSymbol("EUR"+dash+"CAD"+ExtraSymbolChar);
   if (EURCHF) ProcessSymbol("EUR"+dash+"CHF"+ExtraSymbolChar);
   if (EURGBP) ProcessSymbol("EUR"+dash+"GBP"+ExtraSymbolChar);
   if (EURJPY) ProcessSymbol("EUR"+dash+"JPY"+ExtraSymbolChar);
   spacer = 50;
   Row2 = TRUE;
   if (EURUSD) ProcessSymbol("EUR"+dash+"USD"+ExtraSymbolChar);
   if (GBPCHF) ProcessSymbol("GBP"+dash+"CHF"+ExtraSymbolChar);
   if (GBPJPY) ProcessSymbol("GBP"+dash+"JPY"+ExtraSymbolChar);
   if (GBPUSD) ProcessSymbol("GBP"+dash+"USD"+ExtraSymbolChar);
   if (NZDUSD) ProcessSymbol("NZD"+dash+"USD"+ExtraSymbolChar);
   if (USDCAD) ProcessSymbol("USD"+dash+"CAD"+ExtraSymbolChar);
   if (USDCHF) ProcessSymbol("USD"+dash+"CHF"+ExtraSymbolChar);
   if (USDJPY) ProcessSymbol("USD"+dash+"JPY"+ExtraSymbolChar);
   if (EURAUD) ProcessSymbol("EUR"+dash+"AUD"+ExtraSymbolChar);

   ObjectCreate("Time", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Time", "Server Time: "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES), 16, "System", Orange); 
   ObjectSet("Time", OBJPROP_CORNER, 3);
   ObjectSet("Time", OBJPROP_XDISTANCE, 5);
   ObjectSet("Time", OBJPROP_YDISTANCE, 20);

   ObjectCreate("last", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("last", "   Last Alert: "+LastAlert, 20, "System", Orange);
   ObjectSet("last", OBJPROP_CORNER, 2);
   ObjectSet("last", OBJPROP_XDISTANCE, 0);
   ObjectSet("last", OBJPROP_YDISTANCE, 50);
   
   ObjectCreate("copyright", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("copyright", "   Copyright  www.CHICHO MI REY ! !.com ", 14, "System", Orange);
   ObjectSet("copyright", OBJPROP_CORNER, 2);
   ObjectSet("copyright", OBJPROP_XDISTANCE, 0);
   ObjectSet("copyright", OBJPROP_YDISTANCE, 20);
   Sleep(10000); 
   return(0);
}

int SetTitles()
{
   sideways = 0;
   spacer = 20;
   // Title
   ObjectCreate("Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Title", "   TRIPLE  ("+HAS_TF1+")  ("+HAS_TF2+")  ("+HAS_TF3+")MIN HEIKEN ASHI ALIGNMENT ALERT PANEL", 12, "System", Orange);
   ObjectSet("Title", OBJPROP_CORNER, 0);
   ObjectSet("Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Title", OBJPROP_YDISTANCE, spacer);

   spacer = spacer + 30;
   // Pair Title
   ObjectCreate("Pair_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Pair_Title", "   Pair", 9, "System", Orange);
   ObjectSet("Pair_Title", OBJPROP_CORNER, 0);
   ObjectSet("Pair_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Pair_Title", OBJPROP_YDISTANCE, spacer);

   // M5  
   sideways = sideways+110;
   ObjectCreate("M5_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("M5_Title","HAS"+" "+(HAS_TF1), 9, "System", Orange);
   ObjectSet("M5_Title", OBJPROP_CORNER, 0);
   ObjectSet("M5_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("M5_Title", OBJPROP_YDISTANCE, spacer);

   // H1  
   sideways = sideways+90;
   ObjectCreate("H1_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H1_Title", "HAS"+" "+(HAS_TF2), 9, "System", Orange);
   ObjectSet("H1_Title", OBJPROP_CORNER, 0);
   ObjectSet("H1_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H1_Title", OBJPROP_YDISTANCE, spacer);
   
   // H4
   sideways = sideways+90;  
   ObjectCreate("H4_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H4_Title", "HAS"+" "+(HAS_TF3), 9, "System", Orange);
   ObjectSet("H4_Title", OBJPROP_CORNER, 0);
   ObjectSet("H4_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H4_Title", OBJPROP_YDISTANCE, spacer); 
   
   // Last Signal
   sideways = sideways+90;  
   ObjectCreate("Last_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Last_Title", "Last Signal", 9, "System", Orange);
   ObjectSet("Last_Title", OBJPROP_CORNER, 0);
   ObjectSet("Last_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Last_Title", OBJPROP_YDISTANCE, spacer);    

   spacer = 50;
   sideways = 550;
   // Pair Title
   ObjectCreate("Pair_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Pair_Title2", "   Pair", 9, "System", Orange);
   ObjectSet("Pair_Title2", OBJPROP_CORNER, 0);
   ObjectSet("Pair_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Pair_Title2", OBJPROP_YDISTANCE, spacer);

   // M5  
   sideways = sideways+110;
   ObjectCreate("M5_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("M5_Title2", "HAS"+" "+(HAS_TF1), 9, "System", Orange);
   ObjectSet("M5_Title2", OBJPROP_CORNER, 0);
   ObjectSet("M5_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("M5_Title2", OBJPROP_YDISTANCE, spacer);

   // H1  
   sideways = sideways+90; 
   ObjectCreate("H1_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H1_Title2", "HAS"+" "+(HAS_TF2), 9, "System", Orange);
   ObjectSet("H1_Title2", OBJPROP_CORNER, 0);
   ObjectSet("H1_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H1_Title2", OBJPROP_YDISTANCE, spacer);

    //H4 
   sideways = sideways+90;  
   ObjectCreate("H4_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("H4_Title2", "HAS"+" "+(HAS_TF3), 9, "System", Orange);
   ObjectSet("H4_Title2", OBJPROP_CORNER, 0);
   ObjectSet("H4_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("H4_Title2", OBJPROP_YDISTANCE, spacer);

   // Last Signal
   sideways = sideways+90;  
   ObjectCreate("Last_Title2", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Last_Title2", "Last Signal", 9, "System", Orange);
   ObjectSet("Last_Title2", OBJPROP_CORNER, 0);
   ObjectSet("Last_Title2", OBJPROP_XDISTANCE, sideways);
   ObjectSet("Last_Title2", OBJPROP_YDISTANCE, spacer);  
      
}

int ProcessSymbol(string symbol)
{
   color H4_Color;
   color H1_Color;
   color M5_Color;
   color Result_Color;
   string H4_Result;
   string H1_Result;
   string M5_Result;
   
  

     
    
        double fasttrendNow = iCustom(symbol,HAS_TF1,"Heiken_Ashi_Smoothed_v1",FastMaPeriod,FastMaMetod,FastStep,FastBetterFormula,4,habar1);
       
        double slowtrendNow = iCustom(symbol,HAS_TF2,"Heiken_Ashi_Smoothed_v1",SlowMaPeriod,SlowMaMetod,SlowStep,SlowBetterFormula,4,habar2);
        
        double slowertrendNow = iCustom(symbol,HAS_TF3,"Heiken_Ashi_Smoothed_v1",SlowerMaPeriod,SlowerMaMetod,SlowerStep,SlowerBetterFormula,4,habar3);
       
        
        
        
        
  

   double bid = MarketInfo(symbol, MODE_BID);
   bool NoSignal;
   
    
    
     
  //   if (slowtrendNow>0 && fasttrendNow>0 && fasttrendPre<0)
    
     
   //  if (slowtrendNow<0 && fasttrendNow<0 && fasttrendPre>0)


   if (slowertrendNow>0)
   {
      H4_Color = Above;
      H4_Result = "UP";
   } else {
      H4_Color = Below;
     H4_Result = "DWN";
  } 
   if (slowtrendNow>0) 
   {
      H1_Color = Above;
      H1_Result = "UP";
   } else {
      H1_Color = Below;
      H1_Result = "DWN";
   }
   if (fasttrendNow>0)  
   {
      M5_Color = Above;
      M5_Result = "UP";
   } else {
      M5_Color = Below;
      M5_Result = "DWN";
   }        

   ExtraSymbolChar = StringSubstr(Symbol(), 6, 10);

   // SNP500
   if (symbol == "#S&P"+dash+"500_H6"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (SNP500_LastSignal != "UP") Alerts(symbol,H4_Result);   
         SNP500_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (SNP500_LastSignal != "DWN") Alerts(symbol,H4_Result);
         SNP500_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
                              
      if (NoSignal) LastSignal = "NONE";
       else LastSignal = SNP500_LastSignal;
        
           
   }
   
   // NASDAQ
   if (symbol == "#NAS"+dash+"100_H6"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (NASDAQ_LastSignal != "UP") Alerts(symbol,H4_Result);   
         NASDAQ_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (NASDAQ_LastSignal != "DWN") Alerts(symbol,H4_Result);
         NASDAQ_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;        
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = NASDAQ_LastSignal;
   }
   
   // DOWJON
   if (symbol == "#DJ3"+dash+"0_H6"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (DOWJON_LastSignal != "UP") Alerts(symbol,H4_Result);   
         DOWJON_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (DOWJON_LastSignal != "DWN") Alerts(symbol,H4_Result);
         DOWJON_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;   
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = DOWJON_LastSignal;
   }
   
   // US_OIL
   if (symbol == "#US_"+dash+"Oil_H6"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (US_OIL_LastSignal != "UP") Alerts(symbol,H4_Result);   
         US_OIL_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (US_OIL_LastSignal != "DWN") Alerts(symbol,H4_Result);
         US_OIL_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
   if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;      
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = US_OIL_LastSignal;
   }   
   
   // AUDUSD
   if (symbol == "AUD"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (AUDUSD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         AUDUSD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (AUDUSD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         AUDUSD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;    
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = AUDUSD_LastSignal;
   }
   

   
   // EURCAD
   if (symbol == "EUR"+dash+"CAD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURCAD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         EURCAD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURCAD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURCAD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
        if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;   
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURCAD_LastSignal;
   }
   
   // EURCHF
   if (symbol == "EUR"+dash+"CHF"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURCHF_LastSignal != "UP") Alerts(symbol,H4_Result);   
         EURCHF_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURCHF_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURCHF_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURCHF_LastSignal;
   }
   
   // EURGBP
   if (symbol == "EUR"+dash+"GBP"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURGBP_LastSignal != "UP") Alerts(symbol,H4_Result);   
         EURGBP_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURGBP_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURGBP_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
    if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;    
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURGBP_LastSignal;
   }
   
   // EURJPY
   if (symbol == "EUR"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURJPY_LastSignal != "UP") Alerts(symbol,H4_Result);   
         EURJPY_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURJPY_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURJPY_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
        if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;   
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURJPY_LastSignal;
   }
   
   // EURUSD
   if (symbol == "EUR"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURUSD_LastSignal != "UP" && EURUSD_LastSignal != "") Alerts(symbol,H4_Result);   
         EURUSD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURUSD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURUSD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURUSD_LastSignal;
   }
   
   // GBPCHF
   if (symbol == "GBP"+dash+"CHF"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (GBPCHF_LastSignal != "UP") Alerts(symbol,H4_Result);   
         GBPCHF_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (GBPCHF_LastSignal != "DWN") Alerts(symbol,H4_Result);
         GBPCHF_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
    if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = GBPCHF_LastSignal;
   }
   
   // GBPJPY
   if (symbol == "GBP"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (GBPJPY_LastSignal != "UP") Alerts(symbol,H4_Result);   
         GBPJPY_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (GBPJPY_LastSignal != "DWN") Alerts(symbol,H4_Result);
         GBPJPY_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = GBPJPY_LastSignal;
   }
   
   // GBPUSD
   if (symbol == "GBP"+dash+"USD"+ExtraSymbolChar)
   {
   
         
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (GBPUSD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         GBPUSD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (GBPUSD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         GBPUSD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
      
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;    
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = GBPUSD_LastSignal;
   }
   
   // NZDUSD
   if (symbol == "NZD"+dash+"USD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (NZDUSD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         NZDUSD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (NZDUSD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         NZDUSD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE; 
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = NZDUSD_LastSignal;
   }
   
   // USDCAD
   if (symbol == "USD"+dash+"CAD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (USDCAD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         USDCAD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (USDCAD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         USDCAD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
     if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;     
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = USDCAD_LastSignal;
   }
   
   // USDCHF
   if (symbol == "USD"+dash+"CHF"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (USDCHF_LastSignal != "UP") Alerts(symbol,H4_Result);   
         USDCHF_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (USDCHF_LastSignal != "DWN") Alerts(symbol,H4_Result);
         USDCHF_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
     if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;     
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = USDCHF_LastSignal;
   }
   
   // USDJPY
   if (symbol == "USD"+dash+"JPY"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (USDJPY_LastSignal != "UP") Alerts(symbol,H4_Result);   
         USDJPY_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (USDJPY_LastSignal != "DWN") Alerts(symbol,H4_Result);
         USDJPY_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;       
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = USDJPY_LastSignal;
   }
   
    // EURAUD
   if (symbol == "EUR"+dash+"AUD"+ExtraSymbolChar)
   {
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "UP")
      {
         if (EURAUD_LastSignal != "UP") Alerts(symbol,H4_Result);   
         EURAUD_LastSignal = "UP";
         NoSignal = FALSE;
      }
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "DWN")
      {
         if (EURAUD_LastSignal != "DWN") Alerts(symbol,H4_Result);
         EURAUD_LastSignal = "DWN";
         NoSignal = FALSE;       
      }
       
      if (M5_Result == "DWN" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;    
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "UP" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;          
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "DWN") NoSignal = TRUE;    
      if (M5_Result == "UP" && H1_Result == "DWN" && H4_Result == "UP") NoSignal = TRUE;     
      if (M5_Result == "DWN" && H1_Result == "UP" && H4_Result == "DWN") NoSignal = TRUE;  
      
                        
      if (NoSignal) LastSignal = "NONE";
      else LastSignal = EURAUD_LastSignal;
   }
   
   if (LastSignal == "UP") Result_Color = Above;
   if (LastSignal == "DWN") Result_Color = Below;
   if (LastSignal == "NONE") Result_Color = Mixed;
   
   spacer = spacer + 30;
   if (Row2) sideways = 550;
   else sideways = 0;
   ObjectCreate(symbol+"_Title", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"_Title", "   "+symbol, 9, "System", SymbolColor);
   ObjectSet(symbol+"_Title", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"_Title", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"_Title", OBJPROP_YDISTANCE, spacer);

   if (Row2) sideways = 660;
   else sideways = 110;
   ObjectCreate(symbol+"M5_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"M5_Result", M5_Result, 9, "System", M5_Color);
   ObjectSet(symbol+"M5_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"M5_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"M5_Result", OBJPROP_YDISTANCE, spacer);

   if (Row2) sideways = 750;
   else sideways = 200;
   ObjectCreate(symbol+"H1_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"H1_Result", H1_Result, 9, "System", H1_Color);
   ObjectSet(symbol+"H1_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"H1_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"H1_Result", OBJPROP_YDISTANCE, spacer);
   
   if (Row2) sideways = 840;
   else sideways = 290;   
   ObjectCreate(symbol+"H4_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"H4_Result", H4_Result, 9, "System", H4_Color);
   ObjectSet(symbol+"H4_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"H4_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"H4_Result", OBJPROP_YDISTANCE, spacer);
   
   if (Row2) sideways = 930;
   else sideways = 380;    
   ObjectCreate(symbol+"Last_Result", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(symbol+"Last_Result", LastSignal, 9, "System", Result_Color);
   ObjectSet(symbol+"Last_Result", OBJPROP_CORNER, 0);
   ObjectSet(symbol+"Last_Result", OBJPROP_XDISTANCE, sideways);
   ObjectSet(symbol+"Last_Result", OBJPROP_YDISTANCE, spacer);         
}

int Alerts(string symbol, string direction)
{
   if (PopUpAlerts) Alert (StringConcatenate(HAS_TF1+"  "+HAS_TF2+"  "+HAS_TF3+" HAS ALIGNMENT IS " +" "+direction+" on "+symbol)); 
   if (EmailAlerts) SendMail("HAS ALIGNMENT",(StringConcatenate(HAS_TF1+"  "+HAS_TF2+"  "+HAS_TF3+" HAS ALIGNMENT IS " +" "+direction+" on "+symbol))); 
   if (alertsNotify)SendNotification(StringConcatenate(HAS_TF1+"  "+HAS_TF2+"  "+HAS_TF3+" HAS ALIGNMENT IS " +" "+direction+" on "+symbol));
   if (SoundAlerts)   PlaySound(AlertSoundfile); 
  
   LastAlert = direction+" on "+symbol;
}


